#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,ADD10_OUT)
  __DECLARE_VAR(BOOL,EQ13_OUT)
  __DECLARE_VAR(UINT,SEL15_OUT)
  __DECLARE_VAR(BOOL,AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// FUNCTION_BLOCK IF_WORD_BOOL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(WORD,IN0)
  __DECLARE_VAR(BOOL,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,OUT0)
  __DECLARE_VAR(BOOL,OUT1)
  __DECLARE_VAR(BOOL,VAL0)
  __DECLARE_VAR(WORD,VAL_COMP)

} IF_WORD_BOOL;

void IF_WORD_BOOL_init__(IF_WORD_BOOL *data__, BOOL retain);
// Code part
void IF_WORD_BOOL_body__(IF_WORD_BOOL *data__);
// FUNCTION_BLOCK IF_BOOL_WORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,IN0)
  __DECLARE_VAR(WORD,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,OUT0)
  __DECLARE_VAR(WORD,OUT1)
  __DECLARE_VAR(WORD,VAL0)

} IF_BOOL_WORD;

void IF_BOOL_WORD_init__(IF_BOOL_WORD *data__, BOOL retain);
// Code part
void IF_BOOL_WORD_body__(IF_BOOL_WORD *data__);
// FUNCTION_BLOCK IF_WORD_WORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(WORD,IN0)
  __DECLARE_VAR(WORD,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,OUT0)
  __DECLARE_VAR(WORD,OUT1)
  __DECLARE_VAR(WORD,VAL0)
  __DECLARE_VAR(WORD,VAL_COMP)

} IF_WORD_WORD;

void IF_WORD_WORD_init__(IF_WORD_WORD *data__, BOOL retain);
// Code part
void IF_WORD_WORD_body__(IF_WORD_WORD *data__);
// PROGRAM PI_LED_AN_NO_PULL
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,OUT_23)
  __DECLARE_VAR(BOOL,OUT_22)
  __DECLARE_VAR(BOOL,OUT_25)
  __DECLARE_VAR(BOOL,OUT_20)
  __DECLARE_VAR(UINT,INP_AN0)
  __DECLARE_VAR(UINT,INP_AN1)
  __DECLARE_VAR(UINT,INP_AN2)
  __DECLARE_VAR(UINT,INP_AN3)
  TOF TOF3;
  TOF TOF4;
  TOF TOF5;
  __DECLARE_VAR(BOOL,LT32_OUT)
  __DECLARE_VAR(BOOL,GE31_OUT)
  __DECLARE_VAR(BOOL,AND33_OUT)
  __DECLARE_VAR(BOOL,LT28_OUT)
  __DECLARE_VAR(BOOL,GE27_OUT)
  __DECLARE_VAR(BOOL,AND29_OUT)
  __DECLARE_VAR(BOOL,LT44_OUT)
  __DECLARE_VAR(BOOL,GE43_OUT)
  __DECLARE_VAR(BOOL,AND47_OUT)

} PI_LED_AN_NO_PULL;

void PI_LED_AN_NO_PULL_init__(PI_LED_AN_NO_PULL *data__, BOOL retain);
// Code part
void PI_LED_AN_NO_PULL_body__(PI_LED_AN_NO_PULL *data__);
#endif //__POUS_H
